<?php
	class Estadisticas{
		var $CLASS_INFO ;        // Info de la Clase
		var $SqlSrv ;          // Clase SqlServer
		
		function Estadisticas($SqlServer){
			$this->CLASS_INFO['NAME']   = "Rpt" ;
			$this->CLASS_INFO['VERSION'] = "1.0" ;
			if ($SqlServer->CLASS_INFO['NAME'] != "SqlServer" || $SqlServer->CLASS_INFO['VERSION'] < "1.0"){
				die("UserAdmin: Esta clase requiere SqlServer 1.0 o superior.");
			}
			$this->SqlSrv = $SqlServer ;
			return TRUE;
		}
		
		function obtIngresosProveedores($CuitEmpresa='', $fecDesde='', $fecHasta=''){
			$arrReturn = array();
			$query	= "SELECT COUNT(slog.CUITUSUARIO) AS TOTAL,  sxu.XU_NOMBRE AS proveedor FROM slog ";
			$query .= "INNER JOIN sxu  ON slog.CUITUSUARIO = sxu.XU_CUIT ";
			$query .= "INNER JOIN sxue ON sxu.XU_CUIT      = sxue.XUE_CUITUSUARIO ";
			$query .= "WHERE sxue.XUE_CUITEMPRESA = '$CuitEmpresa' ";
			$query .= ( !empty($fecDesde) )? "AND DATE_FORMAT(LOG_FECHA, '%Y%m%d') >= DATE_FORMAT('$fecDesde', '%Y%m%d') " : " ";
			$query .= ( !empty($fecHasta) )? "AND DATE_FORMAT(LOG_FECHA, '%Y%m%d') <= DATE_FORMAT('$fecHasta', '%Y%m%d') " : " ";
			$query .= "AND slog.CUITUSUARIO <> '$CuitEmpresa' ";
			$query .= "GROUP BY slog.CUITUSUARIO ";
			$query .= "ORDER BY TOTAL DESC ";
			$query .= "LIMIT 15 ";
			$result	= $this->SqlSrv->dbQuery($query);
			
			$arrColor = array(
				0=>		"#0D8ECF", 
				1=> 	"#0D8ECF", 
				2=> 	"#0D8ECF", 
				3=> 	"#0D8ECF", 
				4=> 	"#0D8ECF", 
				5=> 	"#0D8ECF",
				6=> 	"#0D8ECF",
				7=> 	"#0D8ECF",
				8=> 	"#0D8ECF",
				9=> 	"#0D8ECF",
				10=> 	"#0D8ECF",
				11=> 	"#0D8ECF",
				12=> 	"#0D8ECF",
				13=> 	"#0D8ECF",
				14=> 	"#0D8ECF"
				);
			
			// $arrColor = array(
				// 0=>		"#FF0F00", 
				// 1=> 	"#FF6600", 
				// 2=> 	"#FF9E01", 
				// 3=> 	"#FCD202", 
				// 4=> 	"#F8FF01", 
				// 5=> 	"#B0DE09",
				// 6=> 	"#04D215",
				// 7=> 	"#0D8ECF",
				// 8=> 	"#0D52D1",
				// 9=> 	"#2A0CD0",
				// 10=> 	"#8A0CCF",
				// 11=> 	"#CD0D74",
				// 12=> 	"#754DEB",
				// 13=> 	"#DDDDDD",
				// 14=> 	"#999999"
				// );
			
			$numrows = $this->SqlSrv->dbNumRows($result);			
			if($numrows){
				for( $i = 0 ; $i < $numrows ; $i++ ) {
					$arrReturn[$i] = $this->SqlSrv->dbGetRow($result,$i);
					$arrReturn[$i]['color'] = $arrColor[$i];
				}
			}
			return $arrReturn;
		}
		
		function obtMotivosConsultas( $CuitEmpresa='', $fecDesde='', $fecHasta='' ){
			$arrCarga	= array();
			$arrReturn	= array();
			$query	= "SELECT MT_CODIGO, MT_DESCRIPCION, CHAT_ESTADO, COUNT(schat.CHAT_MOTIVO) AS TOTAL ";
			$query .= "FROM schat ";
			$query .= "INNER JOIN smt ON schat.CUITEMPRESA = smt.CUITEMPRESA AND MT_CODIGO = schat.CHAT_MOTIVO ";
			$query .= "WHERE smt.CUITEMPRESA = '$CuitEmpresa' ";
			$query .= ( !empty($fecDesde) )? "AND DATE_FORMAT(CHAT_FECAPERTURA, '%Y%m%d') >= DATE_FORMAT('$fecDesde', '%Y%m%d') " : " ";
			$query .= ( !empty($fecHasta) )? "AND DATE_FORMAT(CHAT_FECAPERTURA, '%Y%m%d') <= DATE_FORMAT('$fecHasta', '%Y%m%d') " : " ";
			$query .= "GROUP BY CHAT_MOTIVO, CHAT_ESTADO  ";
			$query .= "ORDER BY TOTAL DESC ";
			$query .= "LIMIT 10 ";
			
			$result	= $this->SqlSrv->dbQuery($query);
			$numrows= $this->SqlSrv->dbNumRows($result);
			$arrEstadistica = array();
			if( $numrows ){
				for( $i = 0 ; $i < $numrows ; $i++ ) {
					$arrCarga[$i] = $this->SqlSrv->dbGetRow($result,$i);
					
					$arrEstadistica[$arrCarga[$i]['MT_CODIGO']]['motivo'] = $arrCarga[$i]['MT_DESCRIPCION'];
					
					if($arrCarga[$i]['CHAT_ESTADO'] == 'PENDIENTE'){
						$arrEstadistica[$arrCarga[$i]['MT_CODIGO']]['pendiente']	= $arrCarga[$i]['TOTAL'];
					}else{
						$arrEstadistica[$arrCarga[$i]['MT_CODIGO']]['cerrado']		= $arrCarga[$i]['TOTAL'];
					}					
				}
				$i = 0;
				foreach($arrEstadistica as $k => $v){
					$arrReturn[$i] = $arrEstadistica[$k];
					$i++;
				}
			}
			return $arrReturn;
		}
		
		function obtIngresos( $CuitEmpresa='', $fecDesde='', $fecHasta='' ){
			$arrCarga	= array();
			$arrReturn	= array();
			$query	= "SELECT LOG_FECHA, COUNT(slog.LOG_IDX) AS TOTAL  ";
			$query .= "FROM slog ";
			$query .= "INNER JOIN sxu ON slog.CUITUSUARIO = sxu.XU_CUIT ";
			$query .= "WHERE slog.CUITEMPRESA = '$CuitEmpresa' ";			
			$query .= "AND `LOG` = 'INGRESO AL SISTEMA' ";
			$query .= "AND slog.CUITUSUARIO <> '$CuitEmpresa' ";
			$query .= ( !empty($fecDesde) )? "AND DATE_FORMAT(LOG_FECHA, '%Y%m%d') >= DATE_FORMAT('$fecDesde', '%Y%m%d') " : " ";
			$query .= ( !empty($fecHasta) )? "AND DATE_FORMAT(LOG_FECHA, '%Y%m%d') <= DATE_FORMAT('$fecHasta', '%Y%m%d') " : " ";
			$query .= "GROUP BY LOG_FECHA ";
			$query .= "ORDER BY LOG_FECHA ASC ";
			$query .= "LIMIT 20 ";
			
			$result	= $this->SqlSrv->dbQuery($query);
			$numrows= $this->SqlSrv->dbNumRows($result);
			$arrEstadistica = array();
			if( $numrows ){
				for( $i = 0 ; $i < $numrows ; $i++ ) {
					$arrReturn[$i] = $this->SqlSrv->dbGetRow($result,$i);					
				}				
			}
			return $arrReturn;
		}
		
		function getPedidoOnTime($CUITUSUARIO='', $CUITEMPRESA=''){
			$arrReturn	= array();
			$YEAR	= '';
			$YEAR	= date('Y');			

			if( !empty($CUITEMPRESA) && !empty($CUITUSUARIO) ){
				$query	= "SELECT MONTH(POCL_FECENTPLAN) AS Mes, COUNT(*) AS Cantidad FROM spocl AS A ";
				$query .= "WHERE CUITUSUARIO = '$CUITUSUARIO' ";
				$query .= "AND CUITEMPRESA = '$CUITEMPRESA' ";
				$query .= "AND POCL_FECENTPLAN >= '$YEAR' ";
				$query .= "GROUP BY month(POCL_FECENTPLAN) ";

				$result	= $this->SqlSrv->dbQuery($query);
				$numrows= $this->SqlSrv->dbNumRows($result);
				$arrEstadistica = array();
				if( $numrows ){
					for( $i = 0 ; $i < $numrows ; $i++ ) {
						$row = $this->SqlSrv->dbGetRow($result,$i);					
						$arrReturn[$i]['Mes'] = $row['Mes'];
						$arrReturn[$i]['Cantidad'] = $row['Cantidad'];
					}
				}				
			}
			return $arrReturn;
		}
		
		function getOkOnTime($CUITUSUARIO='', $CUITEMPRESA=''){
			$arrReturn	= array();
			$YEAR	= '';
			$YEAR	= date('Y');			
			if( !empty($CUITEMPRESA) && !empty($CUITUSUARIO) ){
				$query	= "SELECT MONTH(POCL_FECENTPLAN) AS Mes, COUNT(*) AS Cantidad FROM spocl AS A ";
				$query .= "WHERE CUITUSUARIO = '$CUITUSUARIO' ";
				$query .= "AND CUITEMPRESA = '$CUITEMPRESA' ";
				$query .= "AND POCL_FECENTPLAN >= '$YEAR' ";
				$query .= "AND POCL_FECENT <= POCL_FECENTPLAN ";
				$query .= "GROUP BY month(POCL_FECENTPLAN) ";
				// echo $query;
				$result	= $this->SqlSrv->dbQuery($query);
				$numrows= $this->SqlSrv->dbNumRows($result);
				$arrEstadistica = array();
				if( $numrows ){
					for( $i = 0 ; $i < $numrows ; $i++ ) {
						$row = $this->SqlSrv->dbGetRow($result,$i);					
						$arrReturn[$i]['Mes'] = $row['Mes'];
						$arrReturn[$i]['Cantidad'] = (($row['Cantidad'] == 0)? 0 :  $row['Cantidad']);
					}
				}
			}
			return $arrReturn;
		}
		
		/* OC Proveedores cantidad total de cada linea por mes */
		function obtTotalIsFull($CUITUSUARIO='', $CUITEMPRESA=''){
			$arrReturn	= array();
			$YEAR	= '';
			$YEAR	= date('Y');			

			if( !empty($CUITEMPRESA) && !empty($CUITUSUARIO) ){
				$query	= "SELECT MONTH(POCL_FECENTPLAN) AS Mes, SUM(POCL_CANTPED) AS Cantidad FROM spocl AS A ";
				$query .= "WHERE CUITUSUARIO = '$CUITUSUARIO' ";
				$query .= "AND CUITEMPRESA = '$CUITEMPRESA' ";
				$query .= "AND POCL_FECENTPLAN >= '$YEAR' ";
				$query .= "GROUP BY month(POCL_FECENTPLAN) ";

				$result	= $this->SqlSrv->dbQuery($query);
				$numrows= $this->SqlSrv->dbNumRows($result);
				$arrEstadistica = array();
				if( $numrows ){
					for( $i = 0 ; $i < $numrows ; $i++ ) {
						$row = $this->SqlSrv->dbGetRow($result,$i);					
						$arrReturn[$i]['Mes'] = $row['Mes'];
						$arrReturn[$i]['Cantidad'] = $row['Cantidad'];
					}
				}				
			}
			return $arrReturn;
		}
		
		/* OC Proveedores cantidad total cuplida de cada linea por mes */
		function obtParcialIsFull($CUITUSUARIO='', $CUITEMPRESA=''){
			$arrReturn	= array();
			$YEAR	= '';
			$YEAR	= date('Y');			
			if( !empty($CUITEMPRESA) && !empty($CUITUSUARIO) ){
				$query	= "SELECT MONTH(POCL_FECENTPLAN) AS Mes, SUM(POCL_CANTENT) AS Cantidad FROM spocl AS A ";
				$query .= "WHERE CUITUSUARIO = '$CUITUSUARIO' ";
				$query .= "AND CUITEMPRESA = '$CUITEMPRESA' ";
				$query .= "AND POCL_FECENTPLAN >= '$YEAR' ";
				$query .= "AND POCL_CANTPED = POCL_CANTENT ";
				$query .= "GROUP BY month(POCL_FECENTPLAN) ";
				// echo $query;
				$result	= $this->SqlSrv->dbQuery($query);
				$numrows= $this->SqlSrv->dbNumRows($result);
				$arrEstadistica = array();
				if( $numrows ){
					for( $i = 0 ; $i < $numrows ; $i++ ) {
						$row = $this->SqlSrv->dbGetRow($result,$i);					
						$arrReturn[$i]['Mes'] = $row['Mes'];
						$arrReturn[$i]['Cantidad'] = (($row['Cantidad'] == 0)? 0 :  $row['Cantidad']);
					}
				}
			}
			return $arrReturn;
		}
	}
?>