<?php
class SqlServer {

	var $CLASS_INFO ;						// Info de la Clase
	var $db; 										// Database Link for Read
	var $name;									// Nombre de la base de datos
	var $type; 									// Database Type
	var $dbWrite;								// Database Link for Write
	var $dddb; 									// Database Link for Read
	var $ddname;								// Nombre de la base de datos
	var $ddtype; 								// Database Type
	var $dddbWrite;							// Database Link for Write

	function SqlServer() {
		$this->CLASS_INFO['NAME'] 	 = "SqlServer" ;
		$this->CLASS_INFO['VERSION'] = "1.0" ;
	}

	// Agrega un usuario en la base de datos [V1.0]
	function dbAddUser($user,$password){
		if(!$this->db){
		  $this->dbConnect();
		}
		if ($this->db){
			switch($this->type){
				case 1: // MySql
					if( !$this->dbQuery("grant usage on $this->name.* to $user identified by '$password'") ){
					  echo("<!-- SqlServer: Error adding user -->");
					}
					break ;
				case 2: // Postgres
					if ( !$this->dbQuery("create user $user with password '$password'") ){
					  echo("<!-- SqlServer: Error adding user -->");
					}
					break;
				default:
					echo("<!-- SqlServer: Error wrong database type -->");
			}
		}else{
			echo("<!-- SqlServer: Error no connection with database -->");
		}
		return true ;
	}

	// Borra un usuario en la base de datos [V1.0]
	function dbDropUser($user){
		if(!$this->db){
		  $this->dbConnect();
		}
		if ($this->db){
			switch($this->type){
				case 1: // MySql
					if(!$this->dbQuery("delete from mysql.user where user='$user'")){
					  echo("<!-- SqlServer: Error deleting user  -->");
					}
					if(!$this->dbQuery("delete from mysql.db where user='$user'")){
					  echo("<!-- SqlServer: Error deleting user -->");
					}
					if(!$this->dbQuery("delete from mysql.tables_priv where user='$user'")){
					  echo("<!-- SqlServer: Error deleting user -->");
					}
					if(!$this->dbQuery("delete from mysql.columns_priv where user='$user'")){
					  echo("<!-- SqlServer: Error deleting user -->");
					}
					break;
				case 2: // Postgres
					if(!$this->dbQuery("drop user $user")){
					  echo("<!-- SqlServer: Error deleting user -->");
					}
					break;
				default:
					echo("<!-- SqlServer: Error wrong database type -->");
			}
		}	else {
			echo("<!-- SqlServer: Error no connection with database -->");
		}
		return TRUE;
	}

	// Genera la conexin con la base de datos [V1.0]
	function dbConnect() {
		GLOBAL $dbtype, $dbserverRead, $dbuser, $dbpassword, $dbserverWrite, $dbname;
		GLOBAL $dbddtype, $dbddserverRead, $dbdduser, $dbddpassword, $dbddserverWrite, $dbddname;

		switch($dbtype) {
			case 1: // MySql
				// Intento coneccion en Server Reading [0] (Lectura Primario)
				if ($this->db = @mysql_connect ($dbserverRead[0], $dbuser, $dbpassword)) {
					$dbserverToRead = $dbserverRead[0];
					if(!$this->db){
					  echo "<!-- SqlServer: Error connecting to reading servers... -->";
					}
				}else{
					// Intento coneccion en Server Reading [1] (Lectura Secundario)
					$this->db = @mysql_connect ($dbserverRead[1], $dbuser, $dbpassword);
					if(!$this->db){
					  echo "<!-- SqlServer: Error connecting to reading servers... -->";
					}
					$dbserverToRead = $dbserverRead[1];
				}
				// Chequeo si es el mismo servidor de lectura y escritura
				if ($dbserverToRead == $dbserverWrite) {
					$this->dbWrite = $this->db;
				} else {
					$this->dbWrite = @mysql_connect ($dbserverWrite, $dbuser, $dbpassword);
					if(!$this->dbWrite){
					 echo "<!-- SqlServer: Error connecting to writing servers... -->";
					}
				}

				if(!@mysql_select_db($dbname,$this->db)){
				  echo "<!-- SqlServer: Error setting reading database -->" ;
				}

				if(!@mysql_select_db($dbname,$this->dbWrite)){
				  echo "<!-- SqlServer: Error setting writing database -->" ;
				}
				break ;
			case 2: // Postgres
				$this->db = @pg_pconnect ("host=$dbserver port=$dbport dbname=$dbname user=$dbuser password=$dbpassword");
				if(!$this->db){
				  echo ("<!-- SqlServer: Error connecting -->") ;
				}
				break;
			default:
			  echo "<!-- SqlServer: Error wrong database type -->" ;
		}

		$this->type = $dbtype ;
		$this->name = $dbname ;
		return true ;
	}

	// Cierra la conexin con la base de datos [V1.0]
	function dbDisconnect() {
		if ($this->db) {
			switch($this->type) {
				case 1: // MySql
					$result = @mysql_close($this->db);
					if(!$result){
					 echo("<!-- SqlServer: Error closing database -->");
					}
					break ;
				case 2: // Postgres
					$result = @pg_close($this->db);
					if(!$result){
					 echo("<!-- SqlServer: Error closing database -->");
					}
					break;
				default:
					echo("<!-- SqlServer: Error wrong database type -->");
			}
		}
		if ($this->dbWrite) {
			$result = @mysql_close($this->dbWrite);
			if(!$result){
			 echo("<!-- SqlServer: Error closing database -->");
			}
		}
		$this->type = 0 ;
		return true ;
	}

	// Devuelve el numero de rows de un resultado [V1.0]
	function dbNumRows($result) {
		if(!$this->db){
		  $this->dbConnect();
		}
		$numrows = 0;
		if ($this->db) {
			
			switch($this->type) {
				case 1: // MySql

				  //Controlamos si es cache
				  if(is_string($result)){
				    $arr    = $this->dbGetCache($result);
				    return count($arr);
				  }

					$numrows = mysql_num_rows($result) ;
					break ;
				case 2: // Postgres
					$numrows = pg_numrows($result) ;
					break;
				default:
					echo("<!-- SqlServer: Error wrong database type -->");
			}
		}	else {
			echo("<!-- SqlServer: Error wrong database type -->");
		}
		return $numrows;
	}
	
	function dbGetRows($result){
		$arrResultados = array();
		$total = $this->dbNumRows($result);
		for($i=0; $i<$total; $i++)
		{
			$rs = $this->dbGetRow($result);
			$arrResultados[] = $rs;
		}
		return $arrResultados;
	}

	// Hace el fetch del resultado y lo devuelve 
	function dbGetRow($result) {
		if(!$this->db){
		  $this->dbConnect();
		}

		if ($this->db) {
			switch($this->type) {
				case 1: // MySql

				  if(is_string($result)){
				    $arr    = $this->dbGetCache($result);
				    return $arr[func_get_arg(1)];
				  }

					$row = @mysql_fetch_array($result);
					if(!$row){
					  echo("<!-- SqlServer: Error fetching row <B>$i</B> -->");
					}
					break ;
				case 2: // Postgres
				  //Controlamos si es cache
					$row = @pg_fetch_array($result, func_get_arg(1));
					if(!$row){
					  echo("<!-- SqlServer: Error fetching row <B>$i</B> -->");
					}
					break;
				default:
					echo("<!-- SqlServer: Error wrong database type -->");
			}
		}	else {
		  echo("<!-- SqlServer: Error no connection with database -->");
		}
		return $row;
	}

	// Hace el fetch del campo elegido en el resultado y lo devuelve [V1.0]
	function dbGetRowField($result,$row,$field) {
		if(!$this->db){
		  $this->dbConnect();
		}

		if ($this->db) {
			switch($this->type) {
				case 1: // MySql
					$value = mysql_result($result,$row,$field);
					break;
				case 2: // Postgres
					$value = pg_result($result,$row,$field);
					break;
				default:
					echo("<!-- SqlServer: Error wrong database type -->");
			}
		}	else {
			echo("<!-- SqlServer: Error no connection with database -->");
		}
		return $value;
	}

	// Ejecuta un query en la base de datos [V1.0]
	function dbQuery($query , $db = 0 , $cacheTime = 0 ) {
	  global $testestatica;
		if (!$db){
			if(!$this->db){
				$this->dbConnect();
			}
			$qr = null;
			if ($this->db) {
				switch($this->type) {
					case 1: // MySql
					  $queryCache = $query;
						$dbQueryConnect = (strtolower(substr($query,0,6))=="select") ? $this->db : $this->dbWrite;
						$qr = @mysql_query($query,$dbQueryConnect);
						if(!$qr){
						  echo ("<!-- SqlServer: Error executing query-->");
						}
						break;
					case 2: // Postgres
						$qr = @pg_exec($this->db, $query);
						if(!$qr){
						  echo ("<!-- SqlServer: Error executing query-->");
						}
						break;
					default:
						echo ("<!-- SqlServer: Error wrong database type -->");
				}
			}	else {
				echo ("<!-- SqlServer: Error no connection with database -->");
			}
			return $qr;
		}else{
			if ($this->dddb) {
				switch($this->ddtype) {
					case 1: // MySql
						$dbQueryConnect = ( strtolower(substr($query,0,6)) == "select" ) ? $this->dddb : $this->dddbWrite;
						$qr = @mysql_query($query,$dbQueryConnect);
						if(!$qr){
						  echo ("<!-- SqlServer: Error executing query-->");
						}
						break;
					case 2: // Postgres
						$qr = @pg_exec($this->dddb, $query);
						if(!$qr){
						  echo ("<!-- SqlServer: Error executing query -->");
						}
						break;
					default:
						echo ("<!-- SqlServer: Error wrong database type -->");
				}
			}	else {
				echo ("<!-- SqlServer: Error no connection with database -->");
			}
			return $qr;
		}
	}

	// Ejecuta un query en la base de datos [V1.0]
	function dbQueryInsert($query) {
		$qr = 0;
		if(!$this->dbWrite){
		  $this->dbConnect();
		}

		if ($this->dbWrite) {
			switch($this->type) {
				case 1: // MySql
					$query = "/*".str_replace(array("/*","*/"),"",$_SERVER["HTTP_HOST"].$_SERVER["REQUEST_URI"])."*/".$query;
					if(!mysql_query($query,$this->dbWrite)){
					  echo("<!-- SqlServer: Error executing query-->");
					}
					$qr = mysql_insert_id($this->dbWrite);
					break;
				default:
					echo ("<!-- SqlServer: Error wrong database type -->");
			}
		}	else {
			echo ("<!-- SqlServer: Error no connection with database -->");
		}
		return $qr;
	}

	// Ejecuta un query en la base de datos, si falla no retorna error
	function dbQueryExt($query) {
		if(!$this->db){
		  $this->dbConnect();
		}

		if ($this->db) {
			switch($this->type) {
				case 1: // MySql
					$dbQueryConnect = (strtolower(substr($query,0,6))=="select") ? $this->db : $this->dbWrite;
					$qr = @mysql_query($query,$dbQueryConnect);
					break;
				case 2: // Postgres
					$qr = @pg_exec($this->db, $query);
					break;
				default:
					echo ("<!-- SqlServer: Error wrong database type -->");
			}
		}	else {
			echo ("<!-- SqlServer: Error no connection with database -->");
		}
		return $qr;
	}

	// Mueve el puntero de un result la posicion indicada [V1.0]
	function dbDataSeek($result,$pos) {
		if(!$this->db){
		  $this->dbConnect();
		}

		if ($this->db) {
			switch($this->type) {
				case 1: // MySql
					mysql_data_seek($result,$pos) ;
					break ;
				case 2: // Postgres
					echo ("<!-- SqlServer: Error Not yet Implemented -->");
					break;
				default:
					echo ("<!-- SqlServer: Error wrong database type -->");
			}
		}	else {
			echo ("<!-- SqlServer: Error no connection with database -->");
		}
		return $result ;
	}

	// Muestra los usuarios registrados en el servidor
	function dbShowUsers() {
		if(!$this->db){
		  $this->dbConnect();
		}

		if ($this->db) {
			switch($this->type) {
				case 1: // MySql
					$users = $this->dbQuery("select user from mysql.db where db='$this->name' order by user");
					if(!$users){
					 echo("<!-- SqlServer: Error reading users -->");
					}
					break ;
				case 2: // Postgres (OJO: RETORNA TODOS LOS USUARIOS)
					$users = $this->dbQuery("select usename from pg_shadow order by usename") ;
					if(!$users){
					 echo("<!-- SqlServer: Error reading users -->");
					}
					break;
				default:
					echo ("<!-- SqlServer: Error wrong database type -->");
			}
		}	else {
			echo ("<!-- SqlServer: Error no connection with database -->");
		}
		return $users;
	}

	// Retorna el tipo de base de datos seleccionada
	function dbGetType() {
		if ($this->db) {
			return $this->type;
		} else {
			echo ("<!-- SqlServer: Error No connection with database -->");
		}
	}

	// Retorna el -1 si la tabla no existe, 0 si la tabla esta vacia o 1 si la tabla tiene datos
	function dbGetTableState($Table) {
		if(!$this->db){
		  $this->dbConnect();
		}

		if ($this->db) {
			if ($Table == "") { echo ("<!-- SqlServer: Error Parameter error -->");  }
			switch($this->type) {
				case 1: // MySql
					$qr = @mysql_query("select count(*) from $Table limit 1", $this->db);
					break;
				case 2: // Postgres
					$qr = @pg_exec($this->db, "select count(*) from $Table limit 1");
					break;
				default:
					echo ("<!-- SqlServer: Error wrong database type -->");
			}
			if ($qr === FALSE) return -1;
			if (!$this->dbNumRows($qr)) return 0;
			return ($this->dbGetRowField($qr, 0, 0) ? 1 : 0);
		} else {
			echo ("<!-- SqlServer: Error no connection with database -->");
		}
	}

	// Obtiene el Idx del ultimo INSERT a la tabla especificada 
	// Atencion: Se debe llamar inmediatamente despues de realizado el query
	function dbGetLastIdx($QueryResult, $Table) {
		if(!$this->db){
		  $this->dbConnect();
		}

		if ($this->db) {
			switch($this->type) {
				case 1: // MySql
					return mysql_insert_id();
					break;
				case 2: // Postgres
					if ($Table == "") echo ("<!-- SqlServer: Error Parameter error -->");
					$qr = @pg_exec($this->db, "select idx from $Table where oid=" . pg_getlastoid($QueryResult));
					if ($qr === FALSE) return 0;
					if (!$this->dbNumRows($qr)) return 0;
					return $this->dbGetRowField($qr, 0, 0);
					break;
				default:
					echo ("<!-- SqlServer: Error wrong database type -->");
			}
		} else {
			echo ("<!-- SqlServer: Error no connection with database -->");
		}
	}

  function dbAffectedRows() {
    if(!$this->db){
		  $this->dbConnect();
		}

   return mysql_affected_rows($this->db);
  }
  
}
?>